//
// PS2PC: An Intel x86 emulator for MIPS R5900 (Sony PS2).
// Coded by Mike Tedder / breakpoint - bpoint@parodius.com
// http://ps2pc.parodius.com
//
// This project is released as 'open source'.  You may make any modifications
// or adjustments to the code and submit a patch to be applied to the project.
// See the web page for more details.
//
//-----------------------------------------------------------------------

#include "config.h"
#include "types.h"
#include "debug.h"

#include <stdio.h>
#include <stdarg.h>


void debugInit(void)
{
	debugPrintf("Init.\n");
}

void debugShutdown(void)
{
	debugPrintf("Shutdown.\n");
}

void debugPrintf(char *fmt, ...)
{
	char buf[256];
	va_list	valist;

	// Print debug message to debug window...
	va_start(valist, fmt);
	vsprintf(buf, fmt, valist);
	va_end(valist);

	printf("DEBUG: %s", buf);
}
