//
// PS2PC: An Intel x86 emulator for MIPS R5900 (Sony PS2).
// Coded by Mike Tedder / breakpoint - bpoint@parodius.com
// http://ps2pc.parodius.com
//
// This project is released as 'open source'.  You may make any modifications
// or adjustments to the code and submit a patch to be applied to the project.
// See the web page for more details.
//
//-----------------------------------------------------------------------

#ifndef MEM_H
#define MEM_H

#include "types.h"
#include "x86.h"


bool memInit(void);
void memShutdown(void);

void *memGetBase(void);
ulong memGetSize(void);
void *memCalcSegOfsAddr(ushort seg, ushort ofs);

ulong mem16WriteByte(ulong *out, x86RegByte srcReg, x86MODRMByte16 destAddr, ushort disp);
ulong mem32WriteByte(ulong *out, x86RegByte srcReg, x86MODRMByte32 destAddr, ulong disp);
ulong mem32SIBWriteByte(ulong *out, x86RegByte srcReg, x86MODRMByte32SIB sibAddr, uchar ss, uchar index, ulong disp);

#endif
