//
// PS2PC: An Intel x86 emulator for MIPS R5900 (Sony PS2).
// Coded by Mike Tedder / breakpoint - bpoint@parodius.com
// http://ps2pc.parodius.com
//
// This project is released as 'open source'.  You may make any modifications
// or adjustments to the code and submit a patch to be applied to the project.
// See the web page for more details.
//
//-----------------------------------------------------------------------

#ifndef TYPES_H
#define TYPES_H

#ifndef PS2_VERSION
 #error Include config.h before types.h!
#endif

#ifndef NULL
#ifdef  __cplusplus
#define NULL				0
#else
#define NULL				((void *)0)
#endif
#endif

#ifdef NO_EXTERN
#define GLOBAL
#else
#define GLOBAL extern
#endif

#ifdef DO_DEBUG
#define DEBUG_VER(x);		x;
#else
#define DEBUG_VER(x);		;
#endif

#define ASMFUNC				extern "C"

#define FALSE               0
#define TRUE                1

#define HI_WORD(x)          ( (ushort)((x) >> 16) )
#define LO_WORD(x)          ( (ushort)((x) & 0x0000FFFF) )

#define HI_BYTE(x)          ( (uchar) ((x) >> 8) )
#define LO_BYTE(x)          ( (uchar) ((x) & 0x00FF) )

#define MAKE_WORD(u, l)					((u << 8) | (l))
#define MAKE_DWORD(uu, ul, lu, ll)		((uu << 24) | (ul << 16) | (lu << 8) | ll)

typedef unsigned char       uchar;
typedef unsigned short      ushort;
typedef unsigned int        uint;
typedef   signed char       schar;
typedef   signed short      sshort;
typedef   signed int        sint;

#if (PC_VERSION)
 typedef unsigned long       ulong;
 typedef   signed long       slong;
#elif (PS2_VERSION)
 typedef unsigned int        ulong;			// longs on ps2 are 64-bit, we need 32-bit longs.
 typedef   signed int        slong;
#endif

#endif
