//
// PS2PC: An Intel x86 emulator for MIPS R5900 (Sony PS2).
// Coded by Mike Tedder / breakpoint - bpoint@parodius.com
// http://ps2pc.parodius.com
//
// This project is released as 'open source'.  You may make any modifications
// or adjustments to the code and submit a patch to be applied to the project.
// See the web page for more details.
//
//-----------------------------------------------------------------------

#ifndef X86BIT_H
#define X86BIT_H

#include "types.h"

int x86OR_EbGb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86OR_EvGv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86OR_GbEb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86OR_GvEv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86OR_ALIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86OR_eAXIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86AND_EbGb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86AND_EvGv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86AND_GbEb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86AND_GvEv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86AND_ALIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86AND_eAXIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86XOR_EbGb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86XOR_EvGv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86XOR_GbEb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86XOR_GvEv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86XOR_ALIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86XOR_eAXIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);

#endif
