//
// PS2PC: An Intel x86 emulator for MIPS R5900 (Sony PS2).
// Coded by Mike Tedder / breakpoint - bpoint@parodius.com
// http://ps2pc.parodius.com
//
// This project is released as 'open source'.  You may make any modifications
// or adjustments to the code and submit a patch to be applied to the project.
// See the web page for more details.
//
//-----------------------------------------------------------------------

#ifndef X86MOV_H
#define X86MOV_H

#include "types.h"

int x86MOV_EbGb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_EvGv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_GbEb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_GvEv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_EwSw(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_SwEw(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_ALOb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_eAXOv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_ObAL(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_OveAX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_ALIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_CLIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_DLIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_BLIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_AHIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_CHIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_DHIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_BHIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_eAXIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_eCXIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_eDXIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_eBXIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_eSPIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_eBPIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_eSIIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_eDIIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_EbIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86MOV_EvIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);

#endif
