//
// PS2PC: An Intel x86 emulator for MIPS R5900 (Sony PS2).
// Coded by Mike Tedder / breakpoint - bpoint@parodius.com
// http://ps2pc.parodius.com
//
// This project is released as 'open source'.  You may make any modifications
// or adjustments to the code and submit a patch to be applied to the project.
// See the web page for more details.
//
//-----------------------------------------------------------------------

#ifndef X86STACK_H
#define X86STACK_H

#include "types.h"

int x86PUSH_ES(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_CS(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_SS(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_DS(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_eAX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_eCX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_eDX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_eBX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_eSP(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_eBP(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_eSI(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_eDI(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSHA(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_Iv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSH_Ib(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86PUSHF_Fv(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86POP_ES(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POP_SS(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POP_DS(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POP_eAX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POP_eCX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POP_eDX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POP_eBX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POP_eSP(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POP_eBP(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POP_eSI(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POP_eDI(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POPA(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POP_Ev(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86POPF_Fv(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86ENTER_IwIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86LEAVE(uchar *in, ulong *out, bool *isBranch, ulong *skip);

#endif
